;angular.module('Landers.angular')
    .directive('money', ['Flat', '$compile', '$filter', function(Flat, $compile, $filter){
        Landers.css.add('.cny:after {content:"￥"}');
        return {
            restrict : 'E',
            scope: {
                amount: '=',
            },
            link : function($scope, $ele, $attrs) {
                var ui_sref = $attrs['uiSref'];
                var unit = $attrs['unit'] || '';

                if ($scope.amount) {
                    $scope.amount = parseFloat(parseFloat($scope.amount).toFixed(2));
                }

                $scope.$watch('amount', function(new_value){
                    Flat.set($scope, 'money.unit', unit );
                    Flat.set($scope, 'money.a', !!ui_sref);
                    Flat.set($scope, 'money.span', !ui_sref);
                    var if_class = "{'" + $attrs['class'] + "': amount>=0}";

                    var html = '';
                    html += '<span>';
                    html += '   <em class="cny" ng-show="money.span"></em>';
                    html += '   <span class="amount" ng-if="money.a" ng-class="' + if_class+ '" ng-bind-html="amount"></span>';
                    html += '   <span class="amount" ng-if="money.span" ng-class="' + if_class+ '" ng-bind-html="amount"></span>';
                    html += '   <em class="unit-cny" ng-show="money.unit">{{money.unit}}</em>';
                    html += '</span>';

                    $ele.replaceWith($compile(html)($scope));
                });
            }
        };
    }]);