;angular.module('Landers.angular', [
    'cgNotify',
    'ngclipboard',
])
.run(['$rootScope', function ($rootScope){
    $rootScope.$GEvent = {
        // 剪切板
        clipboard: {
            showTooltip: function(e, title){
                $(e.trigger)
                    .tooltip({
                        title: title,
                    })
                    .tooltip('show')
                    .mouseout(function(){
                        $(this).tooltip('destroy');
                    });
            },
            success: function (e) {
                this.showTooltip(e, '复制成功');
            },
            error: function (e) {
                this.showTooltip(e, '复制失败');
            }
        }
    }
}]);
function angular_scope_apply(scope) {
    if (!scope.$$phase ) {
        if (!scope.hasOwnProperty('$$preventApply') && !scope.$$preventApply) {
            try {
                // console.log('angular_scope_apply');
                scope.$apply();
            } catch(e) {

            }
        }
    }
};