;angular.module('Landers.angular')
    .provider('Dialog', function(){
        var provider = this;
        this.skin = 'ulan';
        this.defaults = {
            effect : 'random'
        };
        this.$get = ['$compile', '$timeout', function($compile, $timeout) {

            //先异步加载css文件，以便Landers.dialog.show为非异步
            Landers.dialog.loadmod(provider.skin);
            return {
                confirm:function(scope, opts, callbacks){
                    callbacks = callbacks || {};
                    callbacks.yesFn = callbacks.yesFn || function () {};
                    callbacks.noFn = callbacks.noFn || function () {};

                    angular.extend(opts, {
                        top : '30%',
                        yes: {text:'　确定　', fn:callbacks.yesFn },
                        no: {text:'　取消　', fn:callbacks.noFn },
                        blur: false,
                        angular : {compile:$compile, scope:scope, timeout:$timeout}
                    });
                    return Landers.dialog.show(opts);
                },
                show:function(scope, opts){
                    var extOpts = opts.compile === false ? {} : {
                        angular : {compile:$compile, scope:scope, timeout:$timeout},
                    };

                    opts = angular.extend({}, provider.defaults, extOpts, opts);
                    return Landers.dialog.show(opts, provider.skin);
                }
            };
        }];
    });